/*#######################################################################################
Communication between AVR and Navilock GPS Modules 

Copyright (C) 2008 Martin Matysiak

Bei Fragen und Verbesserungen wendet euch per EMail an

mail@k621.de

Datenbltter zum Umgang mit Navilock GPS Modulen:

http://www.navilock.de/download/Dokumente_SLASH_Sonstiges/60415_-_Datenblatt_u-blox_GPS_Module/481
http://www.sparkfun.com/datasheets/GPS/NMEA%20Reference%20Manual1.pdf


Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der 
GNU General Public License, wie von der Free Software Foundation verffentlicht, 
weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz oder 
(nach Ihrer Option) jeder spteren Version. 

Die Verffentlichung dieses Programms erfolgt in der Hoffnung, 
da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, 
sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT 
FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License. 

Sie sollten eine Kopie der GNU General Public License zusammen mit diesem 
Programm erhalten haben. 
Falls nicht, schreiben Sie an die Free Software Foundation, 
Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
#######################################################################################*/

#include "gps.h"

//############################################################################
//Routine zur Initialisierung des GPS Moduls
unsigned char gps_init()
//############################################################################
{
	//MosFET anschalten um GPS zu aktualisieren
	GPS_CONF_PORT |= (1 << GPS_PWR_SWITCH);
	GPS_PORT |= (1 << GPS_PWR_SWITCH);

	//USART Schnittstelle initalisieren
	uart_init(UART_BAUD_SELECT(GPS_BAUD, F_CPU));

	return(1);
}

//############################################################################
//Gibt, sobald verfgbar, ein Zeichen vom UART zurck
char gps_get_char()
//############################################################################
{
	unsigned int in = 0;

	do {
		in = uart_getc();
	} while((in & UART_NO_DATA) || (in & UART_BUFFER_OVERFLOW));

	return((char) in);
}

//############################################################################
//Empfngt einen vollstndige NMEA-Befehl und gibt diesen dann zurck
void gps_get_nmea(char* buf, uint8_t bufSize)
//############################################################################
{
	char inChar;
	uint8_t curSize = 0;

	do {
		inChar = gps_get_char();
	} while(inChar != '$');

	while( inChar != '\n' && curSize < bufSize - 2) {
		*buf++ = inChar;
		curSize++;
		inChar = gps_get_char();
	}

	*buf++ = '\n';
	*buf = '\0';
}
